﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;
using System.Diagnostics;

namespace _92611
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           
            DataTable dt = new DataTable();
            dt.Columns.Add("ProfileID", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Coll1", typeof(string));
            dt.Columns.Add("Coll2", typeof(string));

            for (int i = 0; i < 10; i++)
            {
                dt.Rows.Add(i, string.Format("Coll1Value{0}", i), string.Format("Coll2Value{0}", i));
            }
    
            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);
            ultraGrid1.MouseDown += new MouseEventHandler(ultraGrid1_MouseDown);

            ultraGrid1.DataSource = dt;
            
        }

        void ultraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                
                Point p = e.Location;
                Debug.WriteLine (string.Format("{0} {1}", e.Location, p));
                UIElement el = ((UltraGrid)sender).DisplayLayout.UIElement.ElementFromPoint(p);
                UltraGridRow row = null;
                ultraToolbarsManager1.Tools["ButtonTool1"].SharedProps.Enabled = IsRowUI(el, ref row);
                ultraToolbarsManager1.Tools["ButtonTool1"].Tag = row;
            }
        }

        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["ProfileID"].Hidden = true;

        }

        
        private bool IsRowUI(UIElement el, ref UltraGridRow row)
        {
            if (el == null)
                return false;
            if (el is RowUIElement)
            {
                row = ((RowUIElement)el).Row;
                return true;
            }
            else
                return IsRowUI(el.Parent, ref row);

        }

        private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
        {
            UltraToolbarsManager utbm = (UltraToolbarsManager) sender;
            switch (e.Tool.Key)
            {
                case "ButtonTool1":    // ButtonTool
                    if (utbm.Tools["ButtonTool1"].Tag != null && utbm.Tools["ButtonTool1"].Tag is UltraGridRow)
                    {
                        UltraGridRow gridRow = ((UltraGridRow)utbm.Tools["ButtonTool1"].Tag);
                        MessageBox.Show(string.Format("ProfileID: {0}, Coll1: {1}, Coll2: {2} ", gridRow.Cells["ProfileID"].Value, gridRow.Cells["Coll1"].Value, gridRow.Cells["Coll2"].Value));
                    }
                    break;
            }

        }
    }
}
